OPENSSL-DHPARAM(1)

NAME
openssl-dhparam - DH parameter manipulation and generation

SYNOPSIS
openssl dhparam [-help] [-inform DER|PEM] [-outform DER|PEM] [-in filename] [-out filename] [-dsaparam] [-check] [-noout] [-text] [-C] [-2] [-3] [-5] [-engine id] [-rand files] [-writerand file] [numbits]

DESCRIPTION
This command has been deprecated. The openssl-pkeyparam(1) command should be used instead.

This command is used to manipulate DH parameter files.

OPTIONS

-help
    Print out a usage message.

-inform DER|PEM, -outform DER|PEM
    The input format and output format; the default is PEM. The object is compatible with the PKCS#3 DHparameter structure. See "Format Options" in openssl(1) for details.

-in filename
    This specifies the input filename to read parameters from or standard input if this option is not specified.

-out filename
    This specifies the output filename parameters to. Standard output is used if this option is not present. The output filename should not be the same as the input filename.

-dsaparam
    If this option is used, DSA rather than DH parameters are read or created; they are converted to DH format. Otherwise, "strong" primes (such that (p-1)/2 is also prime) will be used for DH parameter generation.

    DH parameter generation with the -dsaparam option is much faster, and the recommended exponent length is shorter, which makes DH key exchange more efficient. Beware that with such DSA-style DH parameters, a fresh DH key should be created for each use to avoid small-subgroup attacks that may be possible otherwise.

-check
    Performs numerous checks to see if the supplied parameters are valid and displays a warning if not.

-2, -3, -5
    The generator to use, either 2, 3 or 5. If present then the input file is ignored and parameters are generated instead. If not present but numbits is present, parameters are generated with the default generator 2.

numbits
    This option specifies that a parameter set should be generated of size numbits. It must be the last option. If this option is present then the input file is ignored and parameters are generated instead. If this option is not present but a generator (-2, -3 or -5) is present, parameters are generated with a default length of 2048 bits. The minimim length is 512 bits. The maximum length is 10000 bits.

-noout
    This option inhibits the output of the encoded version of the parameters.

-text
    This option prints out the DH parameters in human readable form.

-C  This option converts the parameters into C code. The parameters can then be loaded by calling the get_dhNNNN() function.

-engine id
    See "Engine Options" in openssl(1).

-rand files, -writerand file
    See "Random State Options" in openssl(1) for details.

NOTES
This command replaces the dh and gendh commands of previous releases.

OpenSSL currently only supports the older PKCS#3 DH, not the newer X9.42 DH.

This command manipulates DH parameters not keys.

BUGS
There should be a way to generate and manipulate DH keys.

SEE ALSO
openssl(1), openssl-pkeyparam(1), openssl-dsaparam(1)

HISTORY
This command was deprecated in OpenSSL 3.0.

COPYRIGHT
Copyright 2000-2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License"). You may not use this file except in compliance with the License. You can obtain a copy in the file LICENSE in the source distribution or at <https://www.openssl.org/source/license.html>.